/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.party.controller;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.common.constant.Constants;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;

import org.springblade.enterprise.entity.Staff;
import org.springblade.enterprise.feign.IStaffClient;
import org.springblade.enterprise.vo.StaffVO;
import org.springblade.system.expand.feign.IConfClient;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.party.entity.PartyMember;
import org.springblade.party.vo.PartyMemberVO;
import org.springblade.party.wrapper.PartyMemberWrapper;
import org.springblade.party.service.IPartyMemberService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.List;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-03-30
 */
@RestController
@AllArgsConstructor
@RequestMapping("/member")
@Api(value = "", tags = "接口")
public class PartyMemberController extends BladeController {

	private final IPartyMemberService memberService;
	private IStaffClient staffClient;
	private IConfClient confClient;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入member")
	public R<PartyMemberVO> detail(PartyMember partyMember) {
		PartyMember detail = memberService.getOne(Condition.getQueryWrapper(partyMember));
		return R.data(PartyMemberWrapper.build().entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入member")
	public R<IPage<PartyMemberVO>> list(PartyMember partyMember, Query query) {
		IPage<PartyMember> pages = memberService.page(Condition.getPage(query), Condition.getQueryWrapper(partyMember));
		return R.data(PartyMemberWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入member")
	public R<IPage<PartyMemberVO>> page(PartyMemberVO member, Query query) {
		IPage<PartyMemberVO> pages = memberService.selectMemberPage(Condition.getPage(query), member);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入member")
	public R save(@Valid @RequestBody PartyMember partyMember) {
		return R.status(memberService.save(partyMember));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入member")
	public R update(@Valid @RequestBody PartyMember partyMember) {
		return R.status(memberService.updateById(partyMember));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入member")
	public R submit(@Valid @RequestBody PartyMember partyMember) {
		partyMember.setMemberPic(confClient.removePrefix(partyMember.getMemberPic()));
		return R.status(memberService.saveOrUpdate(partyMember));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(memberService.deleteLogic(Func.toLongList(ids)));
	}

	/**
	 * 删除
	 */
	@GetMapping("/isPartyMember")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R isPartyMember(Long id) {
		List<PartyMember> partyMember = memberService.getBaseMapper().selectList(new QueryWrapper<>(new PartyMember()).lambda().eq(PartyMember::getPersonId,id));
		if(partyMember.size()>0 ){
			return R.data(partyMember.get(0));
		}else{
			return R.data(null);
		}
	}


	/**
	 * 园区小程序申请党员
	 */
	@PostMapping("/apply")
	@ApiOperationSupport(order = 8)
	@ApiOperation(value = "申请", notes = "传入member")
	public R apply(@Valid @RequestBody PartyMember partyMember) {
		partyMember.setAuditStatus(0);
		Assert.notNull(partyMember.getPersonType(),"人员类型不能位空");
		if(partyMember.getPersonType() == Constants.PARTY_MEMBER_TYPE_ENTERPRISESTAFF){//员工
			Staff enterpriseStaff = new Staff();
			enterpriseStaff.setId(partyMember.getPersonId());
			StaffVO enterpriseStaffVO = staffClient.detail(enterpriseStaff);
			Assert.notNull(enterpriseStaffVO,"找不到对应的员工信息");
			partyMember.setIdCard(partyMember.getIdCard());
			partyMember.setSex(enterpriseStaffVO.getSex());
			partyMember.setName(enterpriseStaffVO.getRealName());
			partyMember.setPhone(enterpriseStaffVO.getPhone());

		}

		return R.status(memberService.save(partyMember));
	}
}
